/*
 -------------------------------------------------------------------------------
 | Producer - Copyright (C) 2001-2007  Don Burns                               |
 |                                                                             |
 | This library is free software; you can redistribute it and/or modify        |
 | it under the terms of the GNU Lesser General Public License as published    |
 | by the Free Software Foundation; either version 3 of the License, or        |
 | (at your option) any later version.                                         |
 |                                                                             |
 | This library is distributed in the hope that it will be useful, but         |
 | WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY  |
 | or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public     |
 | License for more details.                                                   |
 |                                                                             |
 | You should have received a copy of the GNU Lesser General Public License    |
 | along with this software; if not, write to the Free Software Foundation,    |
 | Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.               |
 |                                                                             |
 -------------------------------------------------------------------------------
 */


#ifndef PRODUCER_VERSION_HEADER_DEF // oops - PRODUCER_VERSION_DEF is defined elsewhere
#define PRODUCER_VERSION_HEADER_DEF 1

#include <Producer/Export.h>
#include <iostream>

namespace Producer {


class PR_EXPORT Version {
    public:
        Version();

        unsigned int getMajor() { return _major; }
        unsigned int getMinor() { return _minor; }
        unsigned int getRelease() { return _release; }
        unsigned int getRevision() { return _revision; }

       friend inline std::ostream& operator << (std::ostream& output, const Version& );

    private:
        unsigned int _major;
        unsigned int _minor;
        unsigned int _release;
        unsigned int _revision;
}; 


inline std::ostream& operator << (std::ostream& out, const Version& version)
{
    out     << version._major << "."
            << version._minor << "."
            << version._release;
    return out; 
}


}

#endif
